<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Install SaltStack</title>

    <link rel="stylesheet" href="/en/latestcss/core.css">
    <link rel="stylesheet" href="/en/latestcss/getstarted.css">
    <link rel="shortcut icon" href="/en/latestcss/images/saltStack_favIcon_32x32.png">

</head>
<body>

<nav id="globalNavbar" class="navbar navbar-default navbar-inverse navbar-fixed-top" role="navigation">
    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="container">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#navbarCollapse">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a href="http://saltstack.com/" target="_blank"><img src="/en/latestcss/images/saltstack.svg" height="40px" width="170px" class="nolightbox"></a>
        </div>
        <!-- Collect the nav links, forms, and other content for toggling -->
        <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="nav navbar-nav">
                <li><a href="/en/latest">Documentation</a></li>
                <li><a href="/en/getstarted/">Tutorials</a></li>
                <li><a href="/en/latestcontents.html">Reference Guide</a></li>
                <li><a href="https://repo.saltstack.com">Downloads</a></li>
                <li><a href="/en/latesttopics/development/">Develop</a></li>
            </ul>
        </div>
    </div>
</nav>

<div class="jumbotron">

    <div class="row row-centered">
        <div class="col-md-9 col-centered">
            <h1>SaltStack Fundamentals</h1>

            <h3>Get Started Tutorial</h3>

        </div>
    </div>
    <!--<div class="gs-top-nav">
        <a href="/en/getstarted/getstarted/index.html">Back to Get Started <i class="glyphicon glyphicon-arrow-left"></i></a><br>
        <a href="/en/getstarted">Back to Documentation <i class="glyphicon glyphicon-arrow-left"></i></a>
    </div>-->
</div>







<div class="container">
    <div class="row">
        <div class="col-md-12">
            <ol class="progtrckr" data-progtrckr-steps="6">
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/fundamentals/index.html">Demo Environment</a>
                </li>
                
                
                
                <li class="progtrckr-done">Install SaltStack</li>
                
                
                
                
                
                
                
                
                
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/fundamentals/remotex.html">Execute Commands</a>
                </li>
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/fundamentals/targeting.html">Targeting</a>
                </li>
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/fundamentals/states.html">Create a Salt State</a>
                </li>
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/fundamentals/top.html">Apply and Target States</a>
                </li>
                
                
            </ol>
        </div>
    </div>

    <div class="row">
        <div class="col-md-1"></div>
        <div class="col-md-10">

            

            <h1>Install SaltStack</h1>

            <div class="section gs-overview">

                
                <p class="p gs-overview-sub"><span class="ph">You'll learn how to:</span></p>

                <ul class="ul">
                    
                    <li class="progtrckr-done">Install SaltStack</li>
                    
                    <li class="progtrckr-done">View and accept connections from managed systems</li>
                    
                    <li class="progtrckr-done">Send a test command to all managed systems</li>
                    
                </ul>
                

                
                <p class="p gs-overview-sub gs-time"><span class="ph">
                              Estimated time: 10 minutes</span>&nbsp;<i
                        class="glyphicon glyphicon-time"></i>
                </p>
                

                
                <p class="p gs-overview-sub gs-difficulty-1"><span class="ph">Difficulty</span>:&nbsp;
                    
                    
                    <i class="glyphicon glyphicon-cog"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                </p>
                
            </div>
            

            <p>To install SaltStack, you’ll need a detailed network diagram with your complete DNS mappings, an enterprise database server, and yeah, you don’t need any of that stuff. All you need is a way to install packages on your systems, and about 10 minutes.</p>
<p>You can install SaltStack from a package manager, pip, directly from source, or using a bootstrap script. SaltStack also provides dedicated tools to create machines and install Salt on public and private clouds (salt-cloud and salt-virt). We won’t cover those tools here, but just know that as soon as you have a system under management, SaltStack is used the same across physical, cloud, and virtual resources.</p>
<h4 id="install">Install</h4>
<p>If you used the Vagrant project that is linked in the <a href="index.html">previous section</a>, SaltStack is already installed and the connections to each minion are already accepted. You can complete the tasks in the <em>Accept Connections</em> below to verify that your minions are connected.</p>
<p>If you are using a different environment, the simplest way to install SaltStack is using the bootstrap script. This script installs SaltStack with a couple of commands on most operating systems. <a id="install-modal" href="#">Show me how to install using bootstrap!</a></p>
<div class="section sidebar">
<p><span id="install-video-modal"><img class="imgcenter nolightbox" width="75%" src="/en/getstarted/images/install-video.png"></span></p>
<h4 id="packages">Packages</h4>
<p>If you cannot use bootstrap, or if you prefer packages, additional installation methods are documented at <a href="http://repo.saltstack.com" class="uri">http://repo.saltstack.com</a>.</p>
<h4 id="terms">Terms</h4>
<p><strong>Salt master</strong>: the central management system.</p>
<p><strong>Salt minion</strong>: a managed system.</p>
<h4 id="architecture-101">Architecture 101</h4>
<div class="figure">
<img class="imgcenter imgscale fifty" src="/en/getstarted/images/arch2.png" />

</div>
</div>
<h2 id="accept-connections">Accept Connections</h2>
<p>Each connection between the Salt master and Salt minion is managed and secured using cryptographic keys. After installation, each Salt minion sends its public key to the Salt master, where it eagerly waits to be accepted. Salt minion keys must be accepted before systems can receive commands from the Salt master.</p>
<p>At the command prompt, <code>cd</code> into the <code>vagrant-demo-master</code> directory and run the following command to log in to your Salt master:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">vagrant</span> ssh master</code></pre>
<p>After you connect, run the following command to become the root user:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">sudo</span> su</code></pre>
<div class="figure">
<img class="imgcenter imgscale fifty" src="/en/getstarted/images/vagrant-ssh-master.png" />

</div>
<h4 id="view-all-keys">View all keys</h4>
<p>On the Salt master, you can quickly view all Salt minion connections and view whether the connection is accepted, rejected, or pending.</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt-key</span> --list-all</code></pre>
<h4 id="accept-a-specific-key">Accept a specific key</h4>
<p>Before a Salt minion can connect, you must accept its key.</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt-key</span> --accept=<span class="kw">&lt;</span>key<span class="kw">&gt;</span></code></pre>
<h4 id="accept-all-keys">Accept all keys</h4>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt-key</span> --accept-all</code></pre>
<div class="figure">
<img class="imgcenter imgscale fifty" src="/en/getstarted/images/vagrant-keys.png" />

</div>
<h2 id="send-a-command">Send a Command</h2>
<p>After you have accepted each key, send a command from your Salt master to verify that your Salt minions are listening:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt</span> <span class="st">&#39;*&#39;</span> test.ping</code></pre>
<div class="figure">
<img class="imgcenter imgscale fifty" src="/en/getstarted/images/vagrant-test.png" />

</div>
<p>If you don’t see all of your Salt minions respond, well that is what happens when you set things up manually. You probably typed something wrong, didn’t accept some keys, or forgot to add a space somewhere (#soml). After your Salt minions are all responding, continue to the next section to put SaltStack to work.</p>


            <br>
            
            <a href="/en/getstarted/fundamentals/index.html">
                <button type="button" class="btn btn-secondary"><span
                        class="glyphicon glyphicon-chevron-left"></span> Previous
                </button>
            </a>
            

            
            <a href="/en/getstarted/fundamentals/remotex.html">
                <button type="button" class="btn btn-primary btn-right">
                    Next <span class="glyphicon glyphicon-chevron-right"></span></button>
            </a>
            

        </div>
        <div class="col-md-1"></div>
    </div>
    <div class="footer">
    <p>© 2020 SaltStack | <a href="http://saltstack.com/privacy-policy" target="_blank">Privacy Policy</a></p>
</div>
</div>

<script type="text/javascript" src="/en/latestjs/core-min.js"></script>


<!--Modals-->
<script type="text/javascript" src="../js/bootbox-min.js"></script>
<script type="text/javascript">
   $( document ).ready(function() {
       
       $("#install-modal").on("click", function(e) {
           e.preventDefault();
           bootbox.dialog({
               title: "Install SaltStack",
               
               message: '<h4>On the Salt Master</h4> <p>Run these commands on the system that you want to use as the central management point:</p> <pre class="language-bash"><code>curl -L https://bootstrap.saltstack.com -o install_salt.sh<br>sudo sh install_salt.sh -M</code></pre>  <p>(note the <strong>-M</strong> option for "install Salt master")</p> <h4>On each Salt Minion</h4> <p>Run these commands on each system that you want to manage using Salt.</p> <pre class="language-bash"><code>curl -L https://bootstrap.saltstack.com -o install_salt.sh<br>sudo sh install_salt.sh</code></pre>  <h4>Salt Hostname</h4> <p>Salt minions attempt to contact the Salt master using the <code>salt</code> hostname. If you don\'t have DNS in your environment, or if the Salt master hostname is something other than <code>salt</code>, you can add the IP address of your Salt master server to the <code>/etc/salt/minion</code> configuration file by changing the <code>master</code> setting.</p> <p>For example, we\'ve set the Salt master setting directly to the IP address we configured for the demo Vagrant files: <img class="imagecenter" src="{{ conf.www_root }}/images/vagrant-master-setting.png"></p> <p>The bootstrap script supports passing the Salt master IP address directly using the <strong>-A</strong> option.</p>',
               buttons: {
                   success: {
                       label: "Got It!"
                   }
               }
           });
       });
       
       $("#install-video-modal").on("click", function(e) {
           e.preventDefault();
           bootbox.dialog({
               title: "SaltStack Installation Demo",
               className: "modal90",
               message: '<video controls autoplay preload="auto" width="640"> <source src="../video/installation.mp4" type="video/mp4" /><source src="../video/installation.webm" type=\'video/webm;codecs="vp8, vorbis"\'/> <p class="vjs-no-js">To view this video please enable JavaScript, and consider upgrading to a web browser that <a href="http://videojs.com/html5-video-support/" target="_blank">supports HTML5 video</a></p> </video>',
               buttons: {
                   success: {
                       label: "Close"
                   }
               }
           });
       });
       
   });
</script>


<!--analytics-->
<script type="text/javascript" language="javascript">llactid=23943</script>
<script type="text/javascript" language="javascript" src="https://trackalyzer.com/trackalyze_secure.js"></script>

<script>
          var _gaq = _gaq || [];
          var pluginUrl = '//www.google-analytics.com/plugins/ga/inpage_linkid.js';
          _gaq.push(['_require', 'inpage_linkid', pluginUrl]);
          _gaq.push(['_setAccount', 'UA-26984928-1']);
          _gaq.push(['_setDomainName', 'saltstack.com']);
          _gaq.push(['_trackPageview']);

          (function() {
              var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
              ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
              var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
          })();

</script>

</body>
</html>